// COMLogXML.h : Declaration of the CCOMLogXML

#ifndef __COMLOGXML_H_
#define __COMLOGXML_H_

#include "resource.h"       // main symbols
#include <mtx.h>

/////////////////////////////////////////////////////////////////////////////
// CCOMLogXML
class ATL_NO_VTABLE CCOMLogXML : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CCOMLogXML, &CLSID_COMLogXML>,
	public ILogbook,
   public IObjectControl,
   public IObjectConstruct
{
public:
	CCOMLogXML();
	virtual ~CCOMLogXML();
   HRESULT  FinalConstruct(void);
   void     FinalRelease(void);

DECLARE_REGISTRY_RESOURCEID(IDR_COMLOGXML)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CCOMLogXML)
	COM_INTERFACE_ENTRY(IObjectControl)
	COM_INTERFACE_ENTRY(IObjectConstruct)
	COM_INTERFACE_ENTRY(ILogbook)
END_COM_MAP()

// ILogbook
public:
	STDMETHOD(LogEvent) (LOG_ENTRY* pEventEntry);
	STDMETHOD(LogMethod)(LOG_ENTRY* pMethodEntry);
	STDMETHOD(LogError) (LOG_ENTRY* pErrorEntry);
// IObjectControl
   STDMETHOD(Activate)(void)       { return S_OK; }
   STDMETHOD_(BOOL, CanBePooled)() { return TRUE; }
   STDMETHOD_(void, Deactivate)()  { }

// IObjectConstruct
   STDMETHOD(Construct)(IDispatch* pCtorObj);

protected:
   CStdioFile m_LogFile;
   DWORD      m_dwMethodIndex;
   DWORD      m_dwEventIndex;
   DWORD      m_dwErrorIndex;


   void GetIDItem(const LOG_ENTRY* pEvent,CString& sID)const;
   void GetLocationItem(const LOG_ENTRY* pEvent,CString& sLocation)const;
   void GetTimeItem(const LOG_ENTRY* pEvent,CString& sTime)const;
   void GetErrorItem(const LOG_ENTRY* pEvent,CString& sError)const;
   void GetEventItem(const LOG_ENTRY* pEvent,CString& sEvent)const;

   void    GetTime(const LOG_ENTRY* pEvent, SYSTEMTIME& systemTime) const;
   void    ConvertGUID(REFGUID guidConst,CString& sGUID)const;
   HRESULT AddFooter();
   HRESULT SetPointer();
   HRESULT FormatNewFile();
   HRESULT WriteString(const CString& sString);
};

#endif //__COMLOGXML_H_
