// CBank.h : Declaration of the CBank

#ifndef __BANK_H_
#define __BANK_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CBank
class ATL_NO_VTABLE CBank : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CBank, &CLSID_Bank>,
	public IDispatchImpl<IAccountsManager, &IID_IAccountsManager, &LIBID_BANKLib>,
	public IDispatchImpl<ILoansManager, &IID_ILoansManager, &LIBID_BANKLib>
{
public:
   CBank(){};
protected:
   HRESULT DoTransfer(int nSum,DWORD dwAccountSrc,DWORD dwAccountDest){return S_OK;};

public:

DECLARE_REGISTRY_RESOURCEID(IDR_BANK)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CBank)
	COM_INTERFACE_ENTRY(ILoansManager)
	COM_INTERFACE_ENTRY(IAccountsManager)
	COM_INTERFACE_ENTRY2(IDispatch, IAccountsManager)
END_COM_MAP()

// IBank
public:
	STDMETHOD(GetBalance)(DWORD dwAccount,int* pnBalance);
	STDMETHOD(CloseAccount)(DWORD dwAccount);
	STDMETHOD(OpenAccount)(DWORD* pdwAccount);
	STDMETHOD(TransferMoney)(int nSum,DWORD dwAccountSrc,DWORD dwAccountDest);
	STDMETHOD(Apply)(DWORD dwAccount,BOOL* pbApproved);
	STDMETHOD(CalcPayment)(DWORD dwSum,DWORD* pdwPayment);
	STDMETHOD(MakePayment)(DWORD dwAccount,DWORD dwSum);
};

#endif //__BANK_H_
